Index: /trunk/src/org/apollo/ApolloSystem.java
===================================================================
--- /trunk/src/org/apollo/ApolloSystem.java	(revision 1101)
+++ /trunk/src/org/apollo/ApolloSystem.java	(revision 1102)
@@ -1,14 +1,8 @@
 package org.apollo;
 
-import java.awt.Image;
-import java.awt.Toolkit;
-import java.awt.event.WindowEvent;
-import java.awt.event.WindowListener;
-import java.net.URL;
 import java.util.Collection;
 import java.util.HashSet;
 import java.util.Set;
 
-import javax.swing.SwingUtilities;
 import javax.swing.UIManager;
 
@@ -29,11 +23,14 @@
 import org.apollo.widgets.FramePlayer;
 import org.expeditee.actions.Actions;
+import org.expeditee.core.BlockingRunnable;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.EcosystemManager.Ecosystem;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gio.InputManager.WindowEventListener;
+import org.expeditee.gio.InputManager.WindowEventType;
 import org.expeditee.gui.Browser;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameKeyboardActions;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.settings.UserSettings;
-import org.expeditee.importer.FrameDNDTransferHandler;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
@@ -47,9 +44,11 @@
 public final class ApolloSystem {
 	
+	private static final String APOLLO_ICON = "org/apollo/icons/mainicon.png";
+	
 	// TODO: Create actual frames
 	public static final String SYSTEM_FRAMESET_NAME = "apollosystem";
 	public static final String HELP_TOP_FRAMENAME = SYSTEM_FRAMESET_NAME + 2;
 	
-//	 TODO: How to get good results: collection (moteef) and querry
+	// TODO: How to get good results: collection (moteef) and querry
 	// TODO: How to omit indexing on tracks 
 	public static final String HELP_MELODYSEARCH_FRAMENAME = SYSTEM_FRAMESET_NAME + 3; 
@@ -58,84 +57,33 @@
 	public static final String SETTINGS_NAME_TIMELINE_LMARGIN = "timelineleftmargin";
 	
-
-
 	public static boolean useQualityGraphics = true;
-	
-	private ApolloSystem() {
-	}
 
 	private static boolean hasInitialized = false;
 	
+	private ApolloSystem()
+	{
+	}
+	
 	/**
 	 * Initializes Apollo mod for expeditee - prepares all subsystems.
 	 */
-	public static void initialize() {
-		
+	public static void initialize()
+	{
 		if (hasInitialized) return;
 
 		ApolloSystemLog.println("Initializing...");
-		
-		SwingUtilities.invokeLater(new Runnable() {
-			public void run() {
-				
-				 try {
-
-					URL url = ClassLoader.getSystemResource("org/apollo/icons/mainicon.png");
-					
-					if (url != null) {
-						 Image img = Toolkit.getDefaultToolkit().getImage(url);
-						 Browser._theBrowser.setIconImage(img);
-					}
-						
-	
-					 
-				 } catch (Exception e) {
-					 e.printStackTrace();
-				 }
-				 
-				// Ensure that resources are released before the application is closed.
-				Browser._theBrowser.addWindowListener(new WindowListener() {
-		
-					public void windowActivated(WindowEvent e) {
-					}
-		
-					public void windowClosed(WindowEvent e) {
-					}
-		
-					public void windowClosing(WindowEvent e) {
-						ApolloSystem.shutdown();
-					}
-		
-					public void windowDeactivated(WindowEvent e) {
-					}
-		
-					public void windowDeiconified(WindowEvent e) {
-					}
-		
-					public void windowIconified(WindowEvent e) {
-					}
-		
-					public void windowOpened(WindowEvent e) {
-					}
-				
-				});
-				
-				Browser._theBrowser.getContentPane().removeKeyListener(FrameKeyboardActions.getInstance());
-				Browser._theBrowser.removeKeyListener(FrameKeyboardActions.getInstance());
-				
-				Browser._theBrowser.getContentPane().addKeyListener(new AudioFrameKeyboardActions());
-				Browser._theBrowser.addKeyListener(new AudioFrameKeyboardActions());
-				
-				// Filter out some special mouse move cases
-				AudioFrameMouseActions apolloMouseFilter = new AudioFrameMouseActions();
-				Browser._theBrowser.getMouseEventRouter().removeExpediteeMouseMotionListener(
-						FrameMouseActions.getInstance());
-				Browser._theBrowser.getMouseEventRouter().addExpediteeMouseMotionListener(apolloMouseFilter);
-				
-				Browser._theBrowser.getMouseEventRouter().removeExpediteeMouseListener(
-						FrameMouseActions.getInstance());
-				Browser._theBrowser.getMouseEventRouter().addExpediteeMouseListener(apolloMouseFilter);
+
+		// Ensure that resources are released before the application is closed.
+		EcosystemManager.getInputManager().addWindowEventListener(new WindowEventListener() {
+			@Override
+			public void onWindowEvent(WindowEventType type)
+			{
+				if (type != WindowEventType.WINDOW_CLOSED) return;
+				ApolloSystem.shutdown();
 			}
 		});
+		
+		EcosystemManager.getInputManager().registerGestureListener(ApolloGestureActions.getInstance());
+		EcosystemManager.getInputManager().addInputEventToGestureTranslator(new ApolloKBMGestureTranslator());
 		
 		// Set title
@@ -161,6 +109,5 @@
 		
 		// Setup for importing audio
-		FrameDNDTransferHandler.getInstance().addCustomFileImporter(
-				new SampledAudioFileImporter());
+		EcosystemManager.getDragAndDropManager().addCustomFileImporter(new SampledAudioFileImporter());
 
 		ApolloSystemLog.println("  Loading actions and agents...");
@@ -202,6 +149,6 @@
 	 * When invoked, the apollo setting frame is loaded and parsed... setting apollo-specific settings.
 	 */
-	public static void loadSettings() {
-
+	public static void loadSettings()
+	{
 		// Load apollo settings frame from the default profile
 		Frame profile = FrameIO.LoadProfile(UserSettings.DEFAULT_PROFILE_NAME);
@@ -241,5 +188,6 @@
 	}
 	
-	private static Mutable.Integer stripNameValueStringInteger(String namevalue) {
+	private static Mutable.Integer stripNameValueStringInteger(String namevalue)
+	{
 		assert (namevalue != null);
 		int valueIndex = namevalue.indexOf(':') + 1;
@@ -259,6 +207,6 @@
 	 * Releases all resources currently used by the SampledAudioManager.
 	 */
-	public static void shutdown() {
-		
+	public static void shutdown()
+	{
 		ApolloSystemLog.println("Saving banks...");
 		SoundDesk.getInstance().saveMasterMix();
@@ -280,5 +228,6 @@
 	 * 		True if has initialized.
 	 */
-	public static boolean isInitialized() {
+	public static boolean isInitialized()
+	{
 		return hasInitialized;
 	}
@@ -294,13 +243,17 @@
 	 * @param args
 	 */
-	public static void main(String[] args) {
-		
-		try {
-	        UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
-	    } 
-	    catch (Exception e) {
-	       e.printStackTrace();
-	       return;
-	    }
+	public static void main(String[] args)
+	{
+		if (Browser.ECOSYSTEM_TYPE == Ecosystem.Swing) {
+			try {
+		        UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
+		    } catch (Exception e) {
+		       e.printStackTrace();
+		       return;
+		    }
+		}
+
+		// Window icon must be set before initialisation
+		GraphicsManager.setWindowIcon(APOLLO_ICON);
 		
 		// Run expeditee
@@ -308,6 +261,6 @@
 		
 		// Initialize apollo
-		SwingUtilities.invokeLater(new Runnable() {
-			public void run() {
+		EcosystemManager.getMiscManager().runOnGIOThread(new BlockingRunnable() {
+			public void execute() {
 				ApolloSystem.initialize();
 			}
Index: /trunk/src/org/apollo/ApolloSystemApplet.java
===================================================================
--- /trunk/src/org/apollo/ApolloSystemApplet.java	(revision 1101)
+++ /trunk/src/org/apollo/ApolloSystemApplet.java	(revision 1102)
@@ -3,5 +3,4 @@
 import java.io.File;
 
-import java.awt.*;
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
Index: /trunk/src/org/apollo/AudioFrameKeyboardActions.java
===================================================================
--- /trunk/src/org/apollo/AudioFrameKeyboardActions.java	(revision 1101)
+++ /trunk/src/org/apollo/AudioFrameKeyboardActions.java	(revision 1102)
@@ -25,5 +25,4 @@
 import org.expeditee.items.Item;
 import org.expeditee.items.Line;
-import org.expeditee.items.Permission;
 import org.expeditee.items.Text;
 import org.expeditee.items.Item.HighlightMode;
Index: /trunk/src/org/apollo/AudioFrameMouseActions.java
===================================================================
--- /trunk/src/org/apollo/AudioFrameMouseActions.java	(revision 1101)
+++ /trunk/src/org/apollo/AudioFrameMouseActions.java	(revision 1102)
@@ -73,6 +73,5 @@
 			FrameMouseActions.MouseY = e.getY();
 			
-		} else if (isSnapOn() &&
-				!FreeItems.getInstance().isEmpty()) { 
+		} else if (isSnapOn() && !FreeItems.getInstance().isEmpty()) { 
 			
 			// Couse movement of free items: Restraining left-most pixel in items
@@ -222,7 +221,7 @@
 					
 					if (firstInitTime == null) {
-						firstInitTime = Mutable.createMutableLong(it.value); // Important to crewate new instance
+						firstInitTime = Mutable.createMutableLong(it.value); // Important to create new instance
 					} else if (it.value < firstInitTime.value) {
-						firstInitTime = Mutable.createMutableLong(it.value); // Important to crewate new instance
+						firstInitTime = Mutable.createMutableLong(it.value); // Important to create new instance
 					}
 				}
Index: /trunk/src/org/apollo/actions/ApolloActions.java
===================================================================
--- /trunk/src/org/apollo/actions/ApolloActions.java	(revision 1101)
+++ /trunk/src/org/apollo/actions/ApolloActions.java	(revision 1102)
@@ -4,7 +4,7 @@
 import org.apollo.widgets.LinkedTrack;
 import org.apollo.widgets.SampleRecorder;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gio.gesture.StandardGestureActions;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.items.Text;
 
@@ -17,12 +17,13 @@
 public class ApolloActions {
 
-	private ApolloActions() {} // Util construction
+	/** Static-only class. */
+	private ApolloActions()
+	{
+	} 
 	
-	/**
-	 * Attatches a new recorder to the cursor
-	 */
-	public static void spawnRecorder() {
-		
-		Frame target = DisplayIO.getCurrentFrame();
+	/** Attaches a new recorder to the cursor. */
+	public static void spawnRecorder()
+	{
+		Frame target = DisplayController.getCurrentFrame();
 		if (target  == null) return;
 
@@ -30,9 +31,9 @@
 		Text source = new Text(target.getNextItemID());
 		source.setParent(target);
-		source.setPosition(FrameMouseActions.MouseX, FrameMouseActions.MouseY);
+		source.setPosition(DisplayController.getMousePosition());
 		SampleRecorder recWidget = new SampleRecorder(source, null);
 		
 		// Pick it up
-		FrameMouseActions.pickup(recWidget.getItems());
+		StandardGestureActions.pickup(recWidget.getItems());
 	}
 	
@@ -42,5 +43,5 @@
 	public static void spawnLinkedTrack() {
 		
-		Frame target = DisplayIO.getCurrentFrame();
+		Frame target = DisplayController.getCurrentFrame();
 		if (target  == null) return;
 
@@ -48,10 +49,10 @@
 		Text source = new Text(target.getNextItemID());
 		source.setParent(target);
-		source.setPosition(FrameMouseActions.MouseX, FrameMouseActions.MouseY);
+		source.setPosition(DisplayController.getMousePosition());
 		
 		LinkedTrack ltWidget = new LinkedTrack(source, null);
 		
 		// Pick it up
-		FrameMouseActions.pickup(ltWidget.getItems());
+		StandardGestureActions.pickup(ltWidget.getItems());
 	}
 	
@@ -64,8 +65,8 @@
 		// Create the launcher
 		FramePlaybackLauncher launcher = new FramePlaybackLauncher(null);
-		launcher.setPosition(FrameMouseActions.MouseX, FrameMouseActions.MouseY);
+		launcher.setPosition(DisplayController.getMousePosition());
 
 		// Pick it up
-		FrameMouseActions.pickup(launcher);
+		StandardGestureActions.pickup(launcher);
 	}
 	
Index: /trunk/src/org/apollo/agents/MelodySearch.java
===================================================================
--- /trunk/src/org/apollo/agents/MelodySearch.java	(revision 1101)
+++ /trunk/src/org/apollo/agents/MelodySearch.java	(revision 1102)
@@ -1,5 +1,4 @@
 package org.apollo.agents;
 
-import java.awt.Color;
 import java.io.File;
 import java.io.FileNotFoundException;
@@ -10,5 +9,4 @@
 
 import javax.sound.sampled.AudioFormat;
-import javax.swing.SwingUtilities;
 
 import org.apollo.ApolloSystem;
@@ -26,12 +24,12 @@
 import org.apollo.widgets.TrackWidgetCommons;
 import org.expeditee.agents.SearchAgent;
+import org.expeditee.core.Colour;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.settings.UserSettings;
 import org.expeditee.settings.folders.FolderSettings;
 import org.expeditee.items.Item;
 import org.expeditee.items.ItemUtils;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.WidgetCorner;
 import org.expeditee.items.widgets.WidgetEdge;
@@ -42,5 +40,5 @@
  * Uses meldex. Thanks David Bainbridge.
  * 
- * The agent runs a querry on the given track widget that launched it.
+ * The agent runs a query on the given track widget that launched it.
  * If the track launches it it does a full search for all tracks on the current frameset.
  * 
@@ -96,5 +94,6 @@
 	 */
 	@Override
-	public boolean initialise(Frame frame, Item item) {
+	public boolean initialise(Frame frame, Item item)
+	{
 		if (!super.initialise(frame, item)) return false;
 		
@@ -104,5 +103,5 @@
 		if (item != null) {
 			
-			InteractiveWidget iw = null;
+			Widget iw = null;
 			
 			if (item instanceof WidgetCorner) {
@@ -162,10 +161,9 @@
 				
 				if (querryMelody == null) { // abort - failed to get audio
-					SwingUtilities.invokeLater(new ExpediteeMessageBayFeedback(
-							"Melody search aborted: Failed to load tracks audio"));
+					overwriteMessage("Melody search aborted: Failed to load tracks audio");
 					_results.addText("Melody search aborted: querry data not good enough to search with", 
-							Color.RED, null, null, false);
+							Colour.RED, null, null, false);
 					_results.addText("Click here for help on melody searches", 
-							new Color(0, 180, 0), ApolloSystem.HELP_MELODYSEARCH_FRAMENAME, null, false);
+							Colour.FromRGB255(0, 180, 0), ApolloSystem.HELP_MELODYSEARCH_FRAMENAME, null, false);
 					
 					_results.save();
@@ -186,9 +184,8 @@
 				
 				if (querryMelody == null) { // abort - failed to get audio
-					SwingUtilities.invokeLater(new ExpediteeMessageBayFeedback(
-							"Melody search aborted: Failed to proccess querry data"));
-					_results.addText("Melody search aborted: querry data not good enough to search with", Color.RED, null, null, false);
+					overwriteMessage("Melody search aborted: Failed to proccess querry data");
+					_results.addText("Melody search aborted: querry data not good enough to search with", Colour.RED, null, null, false);
 					_results.addText("Click here for help on melody searches", 
-							new Color(0, 180, 0), ApolloSystem.HELP_MELODYSEARCH_FRAMENAME, null, false);
+							Colour.FromRGB255(0, 180, 0), ApolloSystem.HELP_MELODYSEARCH_FRAMENAME, null, false);
 					_results.save();
 					return null;
@@ -240,5 +237,5 @@
 					if(!results.isEmpty()) { 
 						_results.addText(frameName + "(" + results.size() + ")", null, frameName, null, false);
-						FrameGraphics.requestRefresh(true);
+						DisplayController.requestRefresh(true);
 					}
 					
@@ -395,7 +392,7 @@
 
 				if (melodyScores.isEmpty() || melodyScores.get(0).getScore() > threshold) {
-					_results.addText("No matches", Color.RED, null, null, false);
+					_results.addText("No matches", Colour.RED, null, null, false);
 					_results.addText("Click here to find out how to improve your melody searches", 
-							new Color(0, 180, 0), ApolloSystem.HELP_MELODYSEARCH_FRAMENAME, null, false);
+							Colour.FromRGB255(0, 180, 0), ApolloSystem.HELP_MELODYSEARCH_FRAMENAME, null, false);
 				} else {
 					
@@ -426,5 +423,5 @@
 			
 			if (_stop) {
-				_results.addText("Search cancelled", Color.RED, null, null, false);
+				_results.addText("Search cancelled", Colour.RED, null, null, false);
 			}
 			
@@ -444,7 +441,4 @@
 		
 	}
-	
-
-	
 	
 	/**
@@ -470,26 +464,3 @@
 
 	}
-	
-	/**
-	 * Safely outputs a message on the messagebay .. if ran on swing thread.
-	 * @author Brook Novak
-	 *
-	 */
-	private class ExpediteeMessageBayFeedback implements Runnable {
-		
-		String feedbackMessage; 
-		
-		public ExpediteeMessageBayFeedback(String feedbackMessage) {
-			assert(feedbackMessage != null);
-			this.feedbackMessage = feedbackMessage;
-		}
-		
-		
-		public void run() {
-			assert(feedbackMessage != null);
-			overwriteMessage(feedbackMessage);
-		}
-	}
-	
-	
 }
Index: /trunk/src/org/apollo/audio/ApolloSubjectChangedEvent.java
===================================================================
--- /trunk/src/org/apollo/audio/ApolloSubjectChangedEvent.java	(revision 1101)
+++ /trunk/src/org/apollo/audio/ApolloSubjectChangedEvent.java	(revision 1102)
@@ -9,5 +9,7 @@
 public final class ApolloSubjectChangedEvent {
 	
-	private ApolloSubjectChangedEvent() {}
+	private ApolloSubjectChangedEvent()
+	{
+	}
 
 	public static final int INPUT_MIXER = 1;
Index: /trunk/src/org/apollo/audio/AudioFormatNotSupportedException.java
===================================================================
--- /trunk/src/org/apollo/audio/AudioFormatNotSupportedException.java	(revision 1101)
+++ /trunk/src/org/apollo/audio/AudioFormatNotSupportedException.java	(revision 1102)
@@ -6,16 +6,20 @@
  * @author Brook Novak
  */
-public class AudioFormatNotSupportedException extends Exception {
+public class AudioFormatNotSupportedException extends Exception
+{
 	protected static final long serialVersionUID = 0L;
 	
-	public AudioFormatNotSupportedException() {
+	public AudioFormatNotSupportedException()
+	{
 		super();
 	}
 	
-	public AudioFormatNotSupportedException(String message) {
+	public AudioFormatNotSupportedException(String message)
+	{
 		super(message);
 	}
 	
-	public AudioFormatNotSupportedException(String message, Exception inner) {
+	public AudioFormatNotSupportedException(String message, Exception inner)
+	{
 		super(message, inner);
 	}
Index: /trunk/src/org/apollo/audio/Metronome.java
===================================================================
--- /trunk/src/org/apollo/audio/Metronome.java	(revision 1101)
+++ /trunk/src/org/apollo/audio/Metronome.java	(revision 1102)
@@ -20,5 +20,6 @@
  *
  */
-public class Metronome extends AbstractSubject {
+public class Metronome extends AbstractSubject
+{
 	
 	private Receiver receiver = null;
Index: /trunk/src/org/apollo/audio/RecordManager.java
===================================================================
--- /trunk/src/org/apollo/audio/RecordManager.java	(revision 1101)
+++ /trunk/src/org/apollo/audio/RecordManager.java	(revision 1102)
@@ -19,6 +19,6 @@
  *
  */
-public class RecordManager extends AbstractSubject  {
-
+public class RecordManager extends AbstractSubject
+{
 	private AudioCaptureThread captureThread = null;
 
Index: /trunk/src/org/apollo/audio/TrackSequence.java
===================================================================
--- /trunk/src/org/apollo/audio/TrackSequence.java	(revision 1101)
+++ /trunk/src/org/apollo/audio/TrackSequence.java	(revision 1102)
@@ -16,5 +16,5 @@
  *
  */
-public final class TrackSequence extends AbstractSubject implements Comparable {
+public final class TrackSequence extends AbstractSubject implements Comparable<TrackSequence> {
 
 	/** FRIENDLY: ONLY TO BE ACCESSED BY AUDIO MIXER. */
@@ -159,11 +159,9 @@
 	 * Order ascending by initiation frame
 	 */
-	public final int compareTo(Object o) {
-		TrackSequence other = (TrackSequence)o; // throws class cast exception
-	
+	public final int compareTo(TrackSequence other)
+	{
 		int cmp = (new Long(initiationFrame)).compareTo(other.initiationFrame);
 
 		if (cmp == 0) {
-			
 			return (new Integer(hashCode()).compareTo(other.hashCode()));
 		}
Index: /trunk/src/org/apollo/audio/structure/AudioStructureModel.java
===================================================================
--- /trunk/src/org/apollo/audio/structure/AudioStructureModel.java	(revision 1101)
+++ /trunk/src/org/apollo/audio/structure/AudioStructureModel.java	(revision 1102)
@@ -3,5 +3,4 @@
 import java.io.FileNotFoundException;
 import java.io.IOException;
-import java.lang.reflect.InvocationTargetException;
 import java.util.HashMap;
 import java.util.HashSet;
@@ -14,5 +13,4 @@
 
 import javax.sound.sampled.UnsupportedAudioFileException;
-import javax.swing.SwingUtilities;
 
 import org.apollo.audio.ApolloSubjectChangedEvent;
@@ -27,20 +25,20 @@
 import org.apollo.widgets.SampledTrack;
 import org.apollo.widgets.TrackWidgetCommons;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.BlockingRunnable;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.settings.UserSettings;
 import org.expeditee.io.Conversion;
 import org.expeditee.items.ItemUtils;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.settings.folders.FolderSettings;
 
 /**
- * A thread safe model of the heirarchical structure of a track graph...
+ * A thread safe model of the hierarchical structure of a track graph...
  * abstracted from Expeditee frames and audio widgets.
  * 
- * The track widgets notifty this model for keeping the structure consistent with
- * expeditees data.
+ * The track widgets notify this model for keeping the structure consistent with
+ * Expeditee's data.
  * 
  * 
@@ -199,6 +197,6 @@
 		NewGraphCommitor commit = new NewGraphCommitor(rootODFrame, newGraph);
 		try {
-			SwingUtilities.invokeAndWait(commit);
-		} catch (InvocationTargetException e) {
+			EcosystemManager.getMiscManager().runOnGIOThread(commit);
+		} catch (Exception e) {
 			e.printStackTrace();
 			assert(false);
@@ -264,6 +262,6 @@
 		
 		try {
-			SwingUtilities.invokeAndWait(cacheFetch);
-		} catch (InvocationTargetException e) {
+			EcosystemManager.getMiscManager().runOnGIOThread(cacheFetch);
+		} catch (Exception e) {
 			e.printStackTrace();
 			assert(false);
@@ -562,5 +560,5 @@
 	 *
 	 */
-	private class ExpediteeCachedTrackInfoFetcher implements Runnable
+	private class ExpediteeCachedTrackInfoFetcher extends BlockingRunnable
 	{
 		private String rootFrameName;
@@ -578,5 +576,5 @@
 		}
 		
-		public void run()
+		public void execute()
 		{
 			assert(rootFrameName != null);
@@ -584,7 +582,7 @@
 			// Check if the current frame
 			Frame rootFrame = null;
-			if (DisplayIO.getCurrentFrame() != null && DisplayIO.getCurrentFrame().getName() != null
-					&& DisplayIO.getCurrentFrame().getName().equals(rootFrameName)) {
-				rootFrame = DisplayIO.getCurrentFrame();
+			if (DisplayController.getCurrentFrame() != null && DisplayController.getCurrentFrame().getName() != null
+					&& DisplayController.getCurrentFrame().getName().equals(rootFrameName)) {
+				rootFrame = DisplayController.getCurrentFrame();
 			} else {
 				// Check if in cache
@@ -597,5 +595,5 @@
 				linkedTracks =  new HashMap<String, LinkedTrackModelData>();
 				
-				for (InteractiveWidget iw : rootFrame.getInteractiveWidgets()) {
+				for (Widget iw : rootFrame.getInteractiveWidgets()) {
 					
 					if (iw instanceof SampledTrack) {
@@ -668,5 +666,5 @@
 	 *
 	 */
-	private class NewGraphCommitor implements Runnable
+	private class NewGraphCommitor extends BlockingRunnable
 	{
 		private final OverdubbedFrame rootODFrame;
@@ -687,5 +685,5 @@
 		}
 		
-		public void run()
+		public void execute()
 		{
 			
@@ -1083,5 +1081,5 @@
 		synchronized(sharedResourceLocker) { // IMPORTANT: Must wait for new graphs to be added to the shared resources
 
-			if (FrameGraphics.isXRayMode()) { // discard whole model
+			if (DisplayController.isXRayMode()) { // discard whole model
 
 				// Neccessary because if the user goes into xray then moves to a new frame
@@ -1422,5 +1420,5 @@
 
 	
-			if (FrameGraphics.isXRayMode()) { // discard whole model
+			if (DisplayController.isXRayMode()) { // discard whole model
 
 				// Neccessary because if the user goes into xray then moves to a new frame
@@ -1610,7 +1608,7 @@
 						
 						try {
-							SwingUtilities.invokeAndWait(new Runnable() {
+							EcosystemManager.getMiscManager().runOnGIOThread(new BlockingRunnable() {
 								
-								public void run() { // on swing thread
+								public void execute() { // on swing thread
 
 									synchronized(sharedResourceLocker) {
@@ -1672,5 +1670,5 @@
 								}
 							});
-						} catch (InvocationTargetException e) {
+						} catch (Exception e) {
 							e.printStackTrace();
 							assert(false);
Index: /trunk/src/org/apollo/audio/util/MultiTrackPlaybackController.java
===================================================================
--- /trunk/src/org/apollo/audio/util/MultiTrackPlaybackController.java	(revision 1101)
+++ /trunk/src/org/apollo/audio/util/MultiTrackPlaybackController.java	(revision 1102)
@@ -9,5 +9,4 @@
 
 import javax.sound.sampled.LineUnavailableException;
-import javax.swing.SwingUtilities;
 
 import org.apollo.audio.ApolloPlaybackMixer;
@@ -31,11 +30,12 @@
 import org.apollo.util.TrackModelHandler;
 import org.apollo.util.TrackModelLoadManager;
-import org.expeditee.gui.DisplayIO;
-import org.expeditee.gui.DisplayIOObserver;
-
+import org.expeditee.core.BlockingRunnable;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gui.DisplayController;
+import org.expeditee.gui.DisplayObserver;
 
 public class MultiTrackPlaybackController 
 	extends AbstractSubject 
-	implements TrackModelHandler, Observer, DisplayIOObserver {
+	implements TrackModelHandler, Observer, DisplayObserver {
 	
 	/** Can be a framename or virtual filename (e.g. from a linked track) */
@@ -91,5 +91,5 @@
 		// After a certain amount of frame changes since the last multi playback has occured
 		// the cached track models are freed to stop consuming all the memory.
-		DisplayIO.addDisplayIOObserver(this);
+		DisplayController.addDisplayObserver(this);
 		
 		// For whenever a track sequence is created - must observe the created track sequences...
@@ -295,7 +295,7 @@
 	 */
 	public void frameChanged() {
-		if (hasTrackCacheExpired() || isPlaying() || isLoading() || DisplayIO.getCurrentFrame() == null) return; // already expired - or is playing - so don't expire!
-		
-		String currentFrameName = DisplayIO.getCurrentFrame().getName();
+		if (hasTrackCacheExpired() || isPlaying() || isLoading() || DisplayController.getCurrentFrame() == null) return; // already expired - or is playing - so don't expire!
+		
+		String currentFrameName = DisplayController.getCurrentFrame().getName();
 		
 		// Free track group every so often.. 
@@ -785,5 +785,5 @@
 			final int id1 = id; 
 			final Object state1 = state;
-			SwingUtilities.invokeLater(new Runnable() {
+			EcosystemManager.getMiscManager().runOnGIOThread(new Runnable() {
 				public void run() {
 					synchronized(listeners1) {
@@ -919,5 +919,5 @@
 	
 				try {
-					SwingUtilities.invokeAndWait(absTrackGraphRetreiver);
+					EcosystemManager.getMiscManager().runOnGIOThread(absTrackGraphRetreiver);
 				} catch (Exception e) {
 					notifyListeners(loadListeners, MultitrackLoadListener.LOAD_FAILED_GENERIC, e, true);
@@ -1095,5 +1095,5 @@
 
 			// Must commence on the swing thread
-			SwingUtilities.invokeLater(new MultiTrackPlaybackCommencer());
+			EcosystemManager.getMiscManager().runOnGIOThread(new MultiTrackPlaybackCommencer());
 		}
 		
@@ -1154,5 +1154,5 @@
 		 * @author Brook Novak
 		 */
-		private class ABSTrackGraphRetreiver implements Runnable {
+		private class ABSTrackGraphRetreiver extends BlockingRunnable {
 			
 			private String masterMixID;
@@ -1165,5 +1165,5 @@
 			}
 			
-			public void run() {
+			public void execute() {
 				assert(rootODFrame != null);
 				assert(masterMixID != null);
Index: /trunk/src/org/apollo/audio/util/PlaybackClock.java
===================================================================
--- /trunk/src/org/apollo/audio/util/PlaybackClock.java	(revision 1101)
+++ /trunk/src/org/apollo/audio/util/PlaybackClock.java	(revision 1102)
@@ -10,5 +10,5 @@
 import org.apollo.mvc.SubjectChangedEvent;
 import org.apollo.util.AudioMath;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.DisplayController;
 
 /**
@@ -161,5 +161,5 @@
 					// Do a repaint is something was listening
 					if (shouldRepaint) {
-						FrameGraphics.requestRefresh(true); // later - should not congest AWT queue
+						DisplayController.requestRefresh(true); // later - should not congest AWT queue
 					}
 					
Index: /trunk/src/org/apollo/audio/util/Timeline.java
===================================================================
--- /trunk/src/org/apollo/audio/util/Timeline.java	(revision 1101)
+++ /trunk/src/org/apollo/audio/util/Timeline.java	(revision 1102)
@@ -6,11 +6,11 @@
  * 
  * <ul>
- * 		<li>The initation point: This is the smallest initiation time 
- * 			<b>(not neccessarily zero)</b> in the frame - at its X pixel.
+ * 		<li>The initiation point: This is the smallest initiation time 
+ * 			<b>(not necessarily zero)</b> in the frame - at its X pixel.
  * 		<li>The end point: This is how long the frame runs for - and the
  * 			x-pixel position of the last played track in the frame.
  * </ul>
  * 
- * They are simple imutable objects thus are not kept consistant with model.
+ * They are simple immutable objects thus are not kept consistent with model.
  * 
  * @author Brook Novak
